/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/*
 * $Id: /local/xerces-c/src/xercesc/dom/DOMLSException.cpp 5521 2007-02-02T17:35:22.685349Z amassari  $
 */

#include "DOMLSException.hpp"
#include <xercesc/util/XMLDOMMsg.hpp>

XERCES_CPP_NAMESPACE_BEGIN

DOMLSException::DOMLSException()
: DOMException()
{      
}

DOMLSException::DOMLSException(    LSExceptionCode              exCode
                                 ,       short                  messageCode
                                 ,       MemoryManager* const   memoryManager)
: DOMException(exCode, messageCode?messageCode:XMLDOMMsg::DOMLSEXCEPTION_ERRX+exCode-DOMLSException::PARSE_ERR+1, memoryManager)
{  
}

DOMLSException::DOMLSException(const DOMLSException &other)
: DOMException(other)
{
}


DOMLSException::~DOMLSException()
{
}

XERCES_CPP_NAMESPACE_END

