/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/*
 * $Id: /local/xerces-c/src/xercesc/dom/impl/DOMXPathNSResolverImpl.hpp 5620 2007-09-12T18:10:17.823587Z amassari  $
 */

#if !defined(XERCESC_INCLUDE_GUARD_DOMXPATHNSRESOLVERIMPL_HPP)
#define XERCESC_INCLUDE_GUARD_DOMXPATHNSRESOLVERIMPL_HPP

#include <xercesc/util/XercesDefs.hpp>
#include <xercesc/dom/DOMXPathNSResolver.hpp>

XERCES_CPP_NAMESPACE_BEGIN

class DOMNode;

class CDOM_EXPORT DOMXPathNSResolverImpl : public DOMXPathNSResolver
{
public:
    DOMXPathNSResolverImpl(const DOMNode *nodeResolver);

    virtual const XMLCh*          lookupNamespaceURI(const XMLCh* prefix) const;
    virtual const XMLCh*          lookupPrefix(const XMLCh* URI) const;

protected:
    const DOMNode*                fResolverNode;
};

XERCES_CPP_NAMESPACE_END

#endif

